## crystal 0.34.0+dfsg

=== Makefile ===
-include Makefile.local # for optional local options e.g. threads

# Recipes for this Makefile

## Build the compiler
##   $ make
## Build the compiler with progress output
##   $ make progress=true
## Clean up built files then build the compiler
##   $ make clean crystal
## Build the compiler in release mode
##   $ make crystal release=1
## Run all specs in verbose mode
##   $ make spec verbose=1

LLVM_CONFIG ?= ## llvm-config command path to use

release ?=      ## Compile in release mode
stats ?=        ## Enable statistics output
progress ?=     ## Enable progress output
threads ?=      ## Maximum number of threads to use
debug ?=        ## Add symbolic debug info
verbose ?=      ## Run specs in verbose mode
junit_output ?= ## Path to output junit results
static ?=       ## Enable static linking

O := .build
SOURCES := $(shell find src -name '*.cr')
SPEC_SOURCES := $(shell find spec -name '*.cr')
override FLAGS += $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )
SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler
SPEC_FLAGS := $(if $(verbose),-v )$(if $(junit_output),--junit_output $(junit_output) )
CRYSTAL_CONFIG_BUILD_COMMIT := $(shell git rev-parse --short HEAD 2> /dev/null)
EXPORTS := \
  $(if $(release),,CRYSTAL_CONFIG_PATH="$(PWD)/src") \
  CRYSTAL_CONFIG_LIBRARY_PATH="$(shell crystal env CRYSTAL_LIBRARY_PATH)" \
  CRYSTAL_CONFIG_BUILD_COMMIT="$(CRYSTAL_CONFIG_BUILD_COMMIT)"
SHELL = sh
LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
LLVM_EXT_DIR = src/llvm/ext
LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
LIB_CRYSTAL_SOURCES = $(shell find src/ext -name '*.c')
LIB_CRYSTAL_OBJS = $(subst .c,.o,$(LIB_CRYSTAL_SOURCES))
LIB_CRYSTAL_TARGET = src/ext/libcrystal.a
DEPS = $(LLVM_EXT_OBJ) $(LIB_CRYSTAL_TARGET)
CFLAGS += -fPIC $(if $(debug),-g -O0)
CXXFLAGS += $(if $(debug),-g -O0)

ifeq ($(shell command -v ld.lld >/dev/null && uname -s),Linux)
  EXPORT_CC ?= CC="cc -fuse-ld=lld"
endif

ifeq (${LLVM_CONFIG},)
  $(error Could not locate llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG)
else
  $(shell echo $(shell printf '\033[33m')Using $(LLVM_CONFIG) [version=$(shell $(LLVM_CONFIG) --version)]$(shell printf '\033[0m') >&2)
endif

.PHONY: all
all: crystal ## Build all files (currently crystal only) [default]

.PHONY: help
help: ## Show this help
	@echo
	@printf '\033[34mtargets:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34moptional variables:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+ \?=.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = " \\?=.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34mrecipes:\033[0m\n'
	@grep -hE '^##.*$$' $(MAKEFILE_LIST) |\
		awk 'BEGIN {FS = "## "}; /^## [a-zA-Z_-]/ {printf "  \033[36m%s\033[0m\n", $$2}; /^##  / {printf "  %s\n", $$2}'

.PHONY: spec
spec: $(O)/all_spec ## Run all specs
	$(O)/all_spec $(SPEC_FLAGS)

.PHONY: std_spec
std_spec: $(O)/std_spec ## Run standard library specs
	$(O)/std_spec $(SPEC_FLAGS)

.PHONY: compiler_spec
compiler_spec: $(O)/compiler_spec ## Run compiler specs
	$(O)/compiler_spec $(SPEC_FLAGS)

.PHONY: docs
docs: ## Generate standard library documentation
	$(BUILD_PATH) ./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS)

.PHONY: crystal
crystal: $(O)/crystal ## Build the compiler

.PHONY: deps llvm_ext libcrystal
deps: $(DEPS) ## Build dependencies

llvm_ext: $(LLVM_EXT_OBJ)
libcrystal: $(LIB_CRYSTAL_TARGET)

$(O)/all_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) $(BUILD_PATH) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/all_spec.cr

$(O)/std_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) $(BUILD_PATH) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/std_spec.cr

$(O)/compiler_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) $(BUILD_PATH) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler_spec.cr

$(O)/crystal: $(DEPS) $(SOURCES)
	@mkdir -p $(O)
	$(BUILD_PATH) $(EXPORTS) ./bin/crystal build $(FLAGS) -o $@ src/compiler/crystal.cr -D without_openssl -D without_zlib

$(LLVM_EXT_OBJ): $(LLVM_EXT_DIR)/llvm_ext.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(shell $(LLVM_CONFIG) --cxxflags)

$(LIB_CRYSTAL_TARGET): $(LIB_CRYSTAL_OBJS)
	$(AR) -rcs $@ $^

.PHONY: clean
clean: clean_crystal ## Clean up built directories and files
	rm -rf $(LLVM_EXT_OBJ)
	rm -rf $(LIB_CRYSTAL_OBJS) $(LIB_CRYSTAL_TARGET)

.PHONY: clean_crystal
clean_crystal: ## Clean up crystal built files
	rm -rf $(O)
	rm -rf ./docs

.PHONY: clean_cache
clean_cache: ## Clean up CRYSTAL_CACHE_DIR files
	rm -rf $(shell ./bin/crystal env CRYSTAL_CACHE_DIR)

=== debian/changelog ===
crystal (0.34.0+dfsg-1ubuntu1) hirsute; urgency=medium

  * debian/control:
    - don't build-depends on libraries which are not available

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 24 Nov 2020 15:25:22 +0100

crystal (0.34.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #822275).

 -- David Suárez <david.sephirot@gmail.com>  Fri, 10 Apr 2020 17:26:40 +0200

=== debian/control ===
Source: crystal
Section: devel
Priority: optional
Maintainer: David Suárez <david.sephirot@gmail.com>
Build-Depends: debhelper-compat (= 12),
               git,
               libbsd-dev,
               libedit-dev,
               libevent-dev,
               libgc-dev (>= 1:7.6.0),
               libgmp-dev,
               libllvm9 | libllvm8,
               libpcre3-dev,
               libssl-dev,
               libtool,
               libxml2-dev,
               libyaml-dev,
               libz-dev,
               lld-9 | lld-8,
               llvm-9-dev | llvm-8-dev,
               pkg-config
Standards-Version: 4.5.0
Homepage: https://crystal-lang.org/
Vcs-Git: https://salsa.debian.org/deiv-guest/crystal-lang.git
Vcs-Browser: https://salsa.debian.org/deiv-guest/crystal-lang
Rules-Requires-Root: no

Package: crystal-lang
Architecture: amd64
Depends: libjs-codemirror,
         libjs-jquery,
         octicons,
         pkg-config,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: crystal-lang-doc, crystal-lang-samples
Description: compiler of the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 The language has the following goals: (1) have the same syntax as Ruby, or at
 least as similar as possible; (2) statically type-checked but without having
 to specify the type of variables or method arguments; (3) be able to call C
 code by writing bindings to it in Crystal; (4) have compile-time evaluation
 and generation of code, to avoid boilerplate code; (5) compile to efficient
 native code.

Package: crystal-lang-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: www-browser
Description: API documentation for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains the documentation for the standard library.

Package: crystal-lang-samples
Architecture: all
Depends: ${misc:Depends}
Description: samples for the Crystal object-oriented programming language
 The Crystal's language syntax is inspired by Ruby, the language is statically
 type-checked but does not require that the type of variables or method
 arguments be specified.
 .
 This package contains some samples for starting to play with the language.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk

N_CPUS=$(shell grep -c "^processor" /proc/cpuinfo 2>/dev/null)

make_options += release=1
make_options += verbose=1
make_options += progress=1
make_options += threads=$(N_CPUS)
make_options += CRYSTAL_CONFIG_PATH="lib:/usr/lib/crystal/lib"
make_options += CRYSTAL_CACHE_DIR="/tmp/crystal"


%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(make_options)
	make $(make_options) docs

override_dh_install:
	dh_install
	
	#
	# clean lib dir, but without deleting (needed by extensions loading):
	#   - ext/libcrystal.a
	#   - llvm/ext/{find-llvm-config, llvm_ext.o)
	#
	find "debian/crystal-lang/usr/lib/crystal/" \
		-iname "sigfault.o" -or \
		-iname "*.c" -or \
		-iname "*.cc" \
		| xargs rm
	
	# fix privacy-breach-generic links on html docs
	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised"\/><\/a><\/p>/!ba};//d' \
		debian/crystal-lang-doc/usr/share/doc/crystal-lang/api-docs/index.html

override_dh_shlibdeps:
	dh_shlibdeps -- -e .build/crystal

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make $(make_options) compiler_spec
	make $(make_options) std_spec
endif

## crystal 1.2.1+dfsg

=== debian/changelog ===
crystal (1.2.1+dfsg-5) unstable; urgency=medium

  * Add patch 'disable-udp-multicast-specs'.

 -- David Suárez <deiv@debian.org>  Mon, 01 Nov 2021 20:54:47 +0100

crystal (1.2.1+dfsg-4) unstable; urgency=medium

  * Use gcc10 until upstream adds support for DWARF 5 (gcc11).

 -- David Suárez <deiv@debian.org>  Mon, 01 Nov 2021 18:30:29 +0100

crystal (1.2.1+dfsg-3) unstable; urgency=medium

  * Use LLVM 12 until 13 gets unblocked.
  * Source upload.

 -- David Suárez <deiv@debian.org>  Sun, 31 Oct 2021 22:49:43 +0100

crystal (1.2.1+dfsg-2) unstable; urgency=medium

  * d/control:
    - Update standars version (no changes needed).
    - Point Vcs-* fields to the updated git repository.
    - Update maintainer to debian account.
    - Update LLVM version.
    - Rename packages to crystal (remove -lang).
    - Add build depend on itself.
  * Update d/copyright.

 -- David Suárez <deiv@debian.org>  Sat, 30 Oct 2021 15:03:25 +0200

crystal (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Update installed files, now makefile comes with install target.
  * Install bash-completion files with the correct name (Closes: #984955).
  * d/rules:
    - Update regex to remove privacy-breach-generic links.
    - Clean gzipped man page.
  * d/control:
    - remove some incorrect build-depends (Closes: #966014)
  * d/patches:
    - drop 'fix-cookie-expire-time-check'; Applied upstream.
    - drop 'update-support-jquery-3'; Applied upstream.
    - drop 'update-packaged-javascript-links'; Not needed.
  * d/copyright: exclude all the minimized javascript code.
  * Compile without support for the playground:
    - The octicons fonts library is removed from testing, so we don't
        build the compiler with the html playground support.
    - Remove all the javascript libraries runtime dependencies.
    - Remove all the copyright's related to the excluded javascript files.
    - Remove 'd/crystal-lang.links'.
    - Remove 'd/missing-sources/materialize.js'.

 -- David Suárez <deiv@debian.org>  Sat, 23 Oct 2021 16:12:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: crystal
 Section: devel
 Priority: optional
-Maintainer: David Suárez <david.sephirot@gmail.com>
+Maintainer: David Suárez <deiv@debian.org>
 Build-Depends: debhelper-compat (= 12),
                git,
                libbsd-dev,
@@ -16,24 +16,24 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-9 | lld-8,
-               llvm-9-dev | llvm-8-dev,
-               pkg-config
-Standards-Version: 4.5.0
+               lld-12 | lld-9 | lld-8,
+               llvm-12-dev | llvm-9-dev | llvm-8-dev,
+               pkg-config,
+               crystal (>= 1.2.1),
+               gcc-10,
+               g++-10
+Standards-Version: 4.6.0
 Homepage: https://crystal-lang.org/
-Vcs-Git: https://salsa.debian.org/deiv-guest/crystal-lang.git
-Vcs-Browser: https://salsa.debian.org/deiv-guest/crystal-lang
+Vcs-Git: https://salsa.debian.org/deiv/crystal.git
+Vcs-Browser: https://salsa.debian.org/deiv/crystal
 Rules-Requires-Root: no
 
-Package: crystal-lang
+Package: crystal
 Architecture: amd64
-Depends: libjs-codemirror,
-         libjs-jquery,
-         octicons,
-         pkg-config,
+Depends: pkg-config,
          ${misc:Depends},
          ${shlibs:Depends}
-Suggests: crystal-lang-doc, crystal-lang-samples
+Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically
  type-checked but does not require that the type of variables or method
@@ -46,7 +46,7 @@
  and generation of code, to avoid boilerplate code; (5) compile to efficient
  native code.
 
-Package: crystal-lang-doc
+Package: crystal-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
@@ -58,7 +58,7 @@
  .
  This package contains the documentation for the standard library.
 
-Package: crystal-lang-samples
+Package: crystal-samples
 Architecture: all
 Depends: ${misc:Depends}
 Description: samples for the Crystal object-oriented programming language

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,18 @@
 make_options += CRYSTAL_CONFIG_PATH="lib:/usr/lib/crystal/lib"
 make_options += CRYSTAL_CACHE_DIR="/tmp/crystal"
 
+export FLAGS = -Dwithout_playground
+
 
 %:
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- $(make_options)
+	CC="gcc-10" CXX="g++-10" dh_auto_build -- $(make_options)
 	make $(make_options) docs
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=/usr
 
 override_dh_install:
 	dh_install
@@ -30,21 +35,23 @@
 	#   - ext/libcrystal.a
 	#   - llvm/ext/{find-llvm-config, llvm_ext.o)
 	#
-	find "debian/crystal-lang/usr/lib/crystal/" \
+	find "debian/crystal/usr/lib/crystal/" \
 		-iname "sigfault.o" -or \
 		-iname "*.c" -or \
 		-iname "*.cc" \
 		| xargs rm
 	
 	# fix privacy-breach-generic links on html docs
-	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised"\/><\/a><\/p>/!ba};//d' \
-		debian/crystal-lang-doc/usr/share/doc/crystal-lang/api-docs/index.html
-
-override_dh_shlibdeps:
-	dh_shlibdeps -- -e .build/crystal
+	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised" \/><\/a><\/p>/!ba};//d' \
+		debian/crystal-doc/usr/share/doc/crystal/api-docs/index.html
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	make $(make_options) compiler_spec
 	make $(make_options) std_spec
 endif
+
+
+override_dh_clean:
+	dh_clean
+	rm -f man/*.gz

## crystal 1.2.2+dfsg

=== Makefile ===
-include Makefile.local # for optional local options e.g. threads

# Recipes for this Makefile

## Build the compiler
##   $ make
## Build the compiler with progress output
##   $ make progress=true
## Clean up built files then build the compiler
##   $ make clean crystal
## Build the compiler in release mode
##   $ make crystal release=1
## Run all specs in verbose mode
##   $ make spec verbose=1

CRYSTAL ?= crystal ## which previous crystal compiler use
LLVM_CONFIG ?=     ## llvm-config command path to use

release ?=      ## Compile in release mode
stats ?=        ## Enable statistics output
progress ?=     ## Enable progress output
threads ?=      ## Maximum number of threads to use
debug ?=        ## Add symbolic debug info
verbose ?=      ## Run specs in verbose mode
junit_output ?= ## Path to output junit results
static ?=       ## Enable static linking

O := .build
SOURCES := $(shell find src -name '*.cr')
SPEC_SOURCES := $(shell find spec -name '*.cr')
override FLAGS += $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )$(if $(target),--cross-compile --target $(target) )
SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler
SPEC_FLAGS := $(if $(verbose),-v )$(if $(junit_output),--junit_output $(junit_output) )
CRYSTAL_CONFIG_LIBRARY_PATH := '$$ORIGIN/../lib/crystal'
CRYSTAL_CONFIG_BUILD_COMMIT := $(shell git rev-parse --short HEAD 2> /dev/null)
CRYSTAL_CONFIG_PATH := '$$ORIGIN/../share/crystal/src'
SOURCE_DATE_EPOCH := $(shell (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile) 2> /dev/null)
EXPORTS := \
  CRYSTAL_CONFIG_BUILD_COMMIT="$(CRYSTAL_CONFIG_BUILD_COMMIT)" \
	CRYSTAL_CONFIG_PATH=$(CRYSTAL_CONFIG_PATH) \
	SOURCE_DATE_EPOCH="$(SOURCE_DATE_EPOCH)"
EXPORTS_BUILD := \
	CRYSTAL_CONFIG_LIBRARY_PATH=$(CRYSTAL_CONFIG_LIBRARY_PATH)
SHELL = sh
LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
LLVM_EXT_DIR = src/llvm/ext
LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
DEPS = $(LLVM_EXT_OBJ)
CXXFLAGS += $(if $(debug),-g -O0)
CRYSTAL_VERSION ?= $(shell cat src/VERSION)

DESTDIR ?=
PREFIX ?= /usr/local
BINDIR ?= $(DESTDIR)$(PREFIX)/bin
MANDIR ?= $(DESTDIR)$(PREFIX)/share/man
LIBDIR ?= $(DESTDIR)$(PREFIX)/lib
DATADIR ?= $(DESTDIR)$(PREFIX)/share/crystal
INSTALL ?= /usr/bin/install

ifeq ($(shell command -v ld.lld >/dev/null && uname -s),Linux)
  EXPORT_CC ?= CC="cc -fuse-ld=lld"
endif

ifeq (${LLVM_CONFIG},)
  $(error Could not locate compatible llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG. Compatible versions: $(shell cat src/llvm/ext/llvm-versions.txt))
else
  $(shell echo $(shell printf '\033[33m')Using $(LLVM_CONFIG) [version=$(shell $(LLVM_CONFIG) --version)]$(shell printf '\033[0m') >&2)
endif

.PHONY: all
all: crystal ## Build all files (currently crystal only) [default]

.PHONY: help
help: ## Show this help
	@echo
	@printf '\033[34mtargets:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34moptional variables:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+ \?=.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = " \\?=.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34mrecipes:\033[0m\n'
	@grep -hE '^##.*$$' $(MAKEFILE_LIST) |\
		awk 'BEGIN {FS = "## "}; /^## [a-zA-Z_-]/ {printf "  \033[36m%s\033[0m\n", $$2}; /^##  / {printf "  %s\n", $$2}'

.PHONY: spec
spec: $(O)/all_spec ## Run all specs
	$(O)/all_spec $(SPEC_FLAGS)

.PHONY: std_spec
std_spec: $(O)/std_spec ## Run standard library specs
	$(O)/std_spec $(SPEC_FLAGS)

.PHONY: compiler_spec
compiler_spec: $(O)/compiler_spec ## Run compiler specs
	$(O)/compiler_spec $(SPEC_FLAGS)

.PHONY: smoke_test ## Build specs as a smoke test
smoke_test: $(O)/std_spec $(O)/compiler_spec $(O)/crystal

.PHONY: docs
docs: ## Generate standard library documentation
	./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS) --project-name=Crystal --project-version=$(CRYSTAL_VERSION) --source-refname=$(CRYSTAL_CONFIG_BUILD_COMMIT)

.PHONY: crystal
crystal: $(O)/crystal ## Build the compiler

.PHONY: deps llvm_ext
deps: $(DEPS) ## Build dependencies
llvm_ext: $(LLVM_EXT_OBJ)

.PHONY: install
install: $(O)/crystal man/crystal.1.gz ## Install the compiler at DESTDIR
	$(INSTALL) -D -m 0755 "$(O)/crystal" "$(BINDIR)/crystal"

	$(INSTALL) -d -m 0755 $(DATADIR)
	cp -av src "$(DATADIR)/src"
	rm -rf "$(DATADIR)/$(LLVM_EXT_OBJ)" # Don't install llvm_ext.o

	$(INSTALL) -D -m 644 man/crystal.1.gz "$(MANDIR)/man1/crystal.1.gz"
	$(INSTALL) -D -m 644 LICENSE "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	$(INSTALL) -D -m 644 etc/completion.bash "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	$(INSTALL) -D -m 644 etc/completion.zsh "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"

.PHONY: uninstall
uninstall: ## Uninstall the compiler from DESTDIR
	rm -f "$(BINDIR)/crystal"

	rm -rf "$(DATADIR)/src"

	rm -f "$(MANDIR)/man1/crystal.1.gz"
	rm -f "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	rm -f "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	rm -f "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"

.PHONY: install_docs
install_docs: docs ## Install docs at DESTDIR
	$(INSTALL) -d -m 0755 $(DATADIR)

	cp -av docs "$(DATADIR)/docs"
	cp -av samples "$(DATADIR)/examples"

.PHONY: uninstall_docs
uninstall_docs: ## Uninstall docs from DESTDIR
	rm -rf "$(DATADIR)/docs"
	rm -rf "$(DATADIR)/examples"

$(O)/all_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/all_spec.cr

$(O)/std_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/std_spec.cr

$(O)/compiler_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler_spec.cr

$(O)/crystal: $(DEPS) $(SOURCES)
	@mkdir -p $(O)
	$(EXPORTS) $(EXPORTS_BUILD) ./bin/crystal build $(FLAGS) -o $@ src/compiler/crystal.cr -D without_openssl -D without_zlib

$(LLVM_EXT_OBJ): $(LLVM_EXT_DIR)/llvm_ext.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(shell $(LLVM_CONFIG) --cxxflags)

man/%.gz: man/%
	gzip -c -9 $< > $@

.PHONY: clean
clean: clean_crystal ## Clean up built directories and files
	rm -rf $(LLVM_EXT_OBJ)

.PHONY: clean_crystal
clean_crystal: ## Clean up crystal built files
	rm -rf $(O)
	rm -rf ./docs

.PHONY: clean_cache
clean_cache: ## Clean up CRYSTAL_CACHE_DIR files
	rm -rf $(shell ./bin/crystal env CRYSTAL_CACHE_DIR)

=== debian/changelog ===
crystal (1.2.2+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Use latest gcc version again.
  * Remove old llvm versions (8 & 9) (Closes: #1001546).

 -- David Suárez <deiv@debian.org>  Thu, 06 Jan 2022 15:21:25 +0100

crystal (1.2.1+dfsg-6) unstable; urgency=medium

  * Fix install target, to allow build arch and indep separately.

 -- David Suárez <deiv@debian.org>  Sun, 07 Nov 2021 17:13:57 +0100

=== debian/control ===
--- 
+++ 
@@ -9,19 +9,16 @@
                libevent-dev,
                libgc-dev (>= 1:7.6.0),
                libgmp-dev,
-               libllvm9 | libllvm8,
                libpcre3-dev,
                libssl-dev,
                libtool,
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-12 | lld-9 | lld-8,
-               llvm-12-dev | llvm-9-dev | llvm-8-dev,
+               lld-12,
+               llvm-12-dev,
                pkg-config,
-               crystal (>= 1.2.1),
-               gcc-10,
-               g++-10
+               crystal (>= 1.2.1)
 Standards-Version: 4.6.0
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git

=== debian/rules ===
--- 
+++ 
@@ -21,21 +21,19 @@
 	dh $@
 
 override_dh_auto_build:
-	CC="gcc-10" CXX="g++-10" dh_auto_build -- $(make_options)
+	dh_auto_build -- $(make_options)
 	make $(make_options) docs
 
+override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
 
-override_dh_install:
-	dh_install
-	
 	#
 	# clean lib dir, but without deleting (needed by extensions loading):
 	#   - ext/libcrystal.a
 	#   - llvm/ext/{find-llvm-config, llvm_ext.o)
 	#
-	find "debian/crystal/usr/lib/crystal/" \
+	find "$(DESTDIR)/usr/share/crystal/src" \
 		-iname "sigfault.o" -or \
 		-iname "*.c" -or \
 		-iname "*.cc" \
@@ -43,7 +41,7 @@
 	
 	# fix privacy-breach-generic links on html docs
 	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised" \/><\/a><\/p>/!ba};//d' \
-		debian/crystal-doc/usr/share/doc/crystal/api-docs/index.html
+		docs/index.html
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

## crystal 1.3.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -24,12 +24,13 @@
 verbose ?=      ## Run specs in verbose mode
 junit_output ?= ## Path to output junit results
 static ?=       ## Enable static linking
+interpreter ?=  ## Enable interpreter feature
 
 O := .build
 SOURCES := $(shell find src -name '*.cr')
 SPEC_SOURCES := $(shell find spec -name '*.cr')
-override FLAGS += $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )$(if $(target),--cross-compile --target $(target) )
-SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler
+override FLAGS += -D strict_multi_assign $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )$(if $(target),--cross-compile --target $(target) )$(if $(interpreter),,-Dwithout_interpreter )
+SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler --exclude-warnings spec/primitives
 SPEC_FLAGS := $(if $(verbose),-v )$(if $(junit_output),--junit_output $(junit_output) )
 CRYSTAL_CONFIG_LIBRARY_PATH := '$$ORIGIN/../lib/crystal'
 CRYSTAL_CONFIG_BUILD_COMMIT := $(shell git rev-parse --short HEAD 2> /dev/null)
@@ -43,6 +44,7 @@
 	CRYSTAL_CONFIG_LIBRARY_PATH=$(CRYSTAL_CONFIG_LIBRARY_PATH)
 SHELL = sh
 LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
+LLVM_VERSION := $(if $(LLVM_CONFIG), $(shell $(LLVM_CONFIG) --version 2> /dev/null))
 LLVM_EXT_DIR = src/llvm/ext
 LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
 DEPS = $(LLVM_EXT_OBJ)
@@ -61,11 +63,17 @@
   EXPORT_CC ?= CC="cc -fuse-ld=lld"
 endif
 
-ifeq (${LLVM_CONFIG},)
-  $(error Could not locate compatible llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG. Compatible versions: $(shell cat src/llvm/ext/llvm-versions.txt))
+ifeq ($(or $(TERM),$(TERM),dumb),dumb)
+  colorize = $(shell printf >&2 "$1")
 else
-  $(shell echo $(shell printf '\033[33m')Using $(LLVM_CONFIG) [version=$(shell $(LLVM_CONFIG) --version)]$(shell printf '\033[0m') >&2)
+  colorize = $(shell printf >&2 "\033[33m$1\033[0m\n")
 endif
+
+check_llvm_config = $(eval \
+	check_llvm_config := $(if $(LLVM_VERSION),\
+	  $(call colorize,Using $(LLVM_CONFIG) [version=$(LLVM_VERSION)]),\
+	  $(error "Could not locate compatible llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG. Compatible versions: $(shell cat src/llvm/ext/llvm-versions.txt)))\
+	)
 
 .PHONY: all
 all: crystal ## Build all files (currently crystal only) [default]
@@ -99,11 +107,20 @@
 compiler_spec: $(O)/compiler_spec ## Run compiler specs
 	$(O)/compiler_spec $(SPEC_FLAGS)
 
+.PHONY: primitives_spec
+primitives_spec: $(O)/primitives_spec ## Run primitives specs
+	$(O)/primitives_spec $(SPEC_FLAGS)
+
 .PHONY: smoke_test ## Build specs as a smoke test
 smoke_test: $(O)/std_spec $(O)/compiler_spec $(O)/crystal
 
+.PHONY: samples ## Build example programs
+samples:
+	$(MAKE) -C samples
+
 .PHONY: docs
 docs: ## Generate standard library documentation
+	$(call check_llvm_config)
 	./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS) --project-name=Crystal --project-version=$(CRYSTAL_VERSION) --source-refname=$(CRYSTAL_CONFIG_BUILD_COMMIT)
 
 .PHONY: crystal
@@ -152,22 +169,31 @@
 	rm -rf "$(DATADIR)/examples"
 
 $(O)/all_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
+	$(call check_llvm_config)
 	@mkdir -p $(O)
 	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/all_spec.cr
 
 $(O)/std_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
+	$(call check_llvm_config)
 	@mkdir -p $(O)
 	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/std_spec.cr
 
 $(O)/compiler_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
+	$(call check_llvm_config)
 	@mkdir -p $(O)
 	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler_spec.cr
 
+$(O)/primitives_spec: $(O)/crystal $(DEPS) $(SOURCES) $(SPEC_SOURCES)
+	@mkdir -p $(O)
+	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/primitives_spec.cr
+
 $(O)/crystal: $(DEPS) $(SOURCES)
+	$(call check_llvm_config)
 	@mkdir -p $(O)
 	$(EXPORTS) $(EXPORTS_BUILD) ./bin/crystal build $(FLAGS) -o $@ src/compiler/crystal.cr -D without_openssl -D without_zlib
 
 $(LLVM_EXT_OBJ): $(LLVM_EXT_DIR)/llvm_ext.cc
+	$(call check_llvm_config)
 	$(CXX) -c $(CXXFLAGS) -o $@ $< $(shell $(LLVM_CONFIG) --cxxflags)
 
 man/%.gz: man/%

=== debian/changelog ===
crystal (1.3.2+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Switch to llvm-toolchain-13 (Closes: #1004882).
  * Add missing dependency on libgc-dev (Closes: #1010249).
  * Update standars version; No changes needed.
  * Update remove privacy-breach sed expression.
  * Use makefile install target.
  * Add patch 'remove-check-in-random-failing-test'.
  * Run primitives spec.

 -- David Suárez <deiv@debian.org>  Sun, 12 Jun 2022 21:16:22 +0200

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,11 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-12,
-               llvm-12-dev,
+               lld-13,
+               llvm-13-dev,
                pkg-config,
                crystal (>= 1.2.1)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
 Vcs-Browser: https://salsa.debian.org/deiv/crystal
@@ -29,7 +29,8 @@
 Architecture: amd64
 Depends: pkg-config,
          ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         libgc-dev
 Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically
@@ -63,4 +64,4 @@
  type-checked but does not require that the type of variables or method
  arguments be specified.
  .
- This package contains some samples for starting to play with the language.
+ This package contains some examples for starting to play with the language.

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,6 @@
 
 override_dh_auto_build:
 	dh_auto_build -- $(make_options)
-	make $(make_options) docs
 
 override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
 override_dh_auto_install:
@@ -38,15 +37,21 @@
 		-iname "*.c" -or \
 		-iname "*.cc" \
 		| xargs rm
+		
+	make install_docs DATADIR=$(DESTDIR)/usr/share/doc/crystal
 	
 	# fix privacy-breach-generic links on html docs
-	sed -i  '/<p><a href=/{:a;N;/alt="born-and-raised" \/><\/a><\/p>/!ba};//d' \
-		docs/index.html
+	sed -i  '/<p><a href=/{:a;N;/alt="Crystal - Born and raised at Manas" \/><\/a><\/p>/!ba};//d' \
+		$(DESTDIR)/usr/share/doc/crystal/docs/index.html
+		
+	# remove vcs file in examples
+	rm -f $(DESTDIR)/usr/share/doc/crystal/examples/.gitignore
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	make $(make_options) compiler_spec
 	make $(make_options) std_spec
+	make $(make_options) primitives_spec
 endif

## crystal 1.6.0+dfsg

=== Makefile ===
-include Makefile.local # for optional local options e.g. threads

# Recipes for this Makefile

## Build the compiler
##   $ make
## Build the compiler with progress output
##   $ make progress=true
## Clean up built files then build the compiler
##   $ make clean crystal
## Build the compiler in release mode
##   $ make crystal release=1
## Run all specs in verbose mode
##   $ make spec verbose=1

CRYSTAL ?= crystal ## which previous crystal compiler use
LLVM_CONFIG ?=     ## llvm-config command path to use

release ?=      ## Compile in release mode
stats ?=        ## Enable statistics output
progress ?=     ## Enable progress output
threads ?=      ## Maximum number of threads to use
debug ?=        ## Add symbolic debug info
verbose ?=      ## Run specs in verbose mode
junit_output ?= ## Path to output junit results
static ?=       ## Enable static linking
interpreter ?=  ## Enable interpreter feature
check ?=        ## Enable only check when running format

O := .build
SOURCES := $(shell find src -name '*.cr')
SPEC_SOURCES := $(shell find spec -name '*.cr')
override FLAGS += -D strict_multi_assign $(if $(release),--release )$(if $(stats),--stats )$(if $(progress),--progress )$(if $(threads),--threads $(threads) )$(if $(debug),-d )$(if $(static),--static )$(if $(LDFLAGS),--link-flags="$(LDFLAGS)" )$(if $(target),--cross-compile --target $(target) )$(if $(interpreter),,-Dwithout_interpreter )
SPEC_WARNINGS_OFF := --exclude-warnings spec/std --exclude-warnings spec/compiler --exclude-warnings spec/primitives
SPEC_FLAGS := $(if $(verbose),-v )$(if $(junit_output),--junit_output $(junit_output) )
CRYSTAL_CONFIG_LIBRARY_PATH := '$$ORIGIN/../lib/crystal'
CRYSTAL_CONFIG_BUILD_COMMIT := $(shell git rev-parse --short HEAD 2> /dev/null)
CRYSTAL_CONFIG_PATH := '$$ORIGIN/../share/crystal/src'
SOURCE_DATE_EPOCH := $(shell (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile) 2> /dev/null)
ifeq ($(shell command -v ld.lld >/dev/null && uname -s),Linux)
  EXPORT_CC ?= CC="$(CC) -fuse-ld=lld"
endif
EXPORTS := \
  CRYSTAL_CONFIG_BUILD_COMMIT="$(CRYSTAL_CONFIG_BUILD_COMMIT)" \
	CRYSTAL_CONFIG_PATH=$(CRYSTAL_CONFIG_PATH) \
	SOURCE_DATE_EPOCH="$(SOURCE_DATE_EPOCH)"
EXPORTS_BUILD := \
	$(EXPORT_CC) \
	CRYSTAL_CONFIG_LIBRARY_PATH=$(CRYSTAL_CONFIG_LIBRARY_PATH)
SHELL = sh
LLVM_CONFIG := $(shell src/llvm/ext/find-llvm-config)
LLVM_VERSION := $(if $(LLVM_CONFIG), $(shell $(LLVM_CONFIG) --version 2> /dev/null))
LLVM_EXT_DIR = src/llvm/ext
LLVM_EXT_OBJ = $(LLVM_EXT_DIR)/llvm_ext.o
DEPS = $(LLVM_EXT_OBJ)
CXXFLAGS += $(if $(debug),-g -O0)
CRYSTAL_VERSION ?= $(shell cat src/VERSION)

DESTDIR ?=
PREFIX ?= /usr/local
BINDIR ?= $(DESTDIR)$(PREFIX)/bin
MANDIR ?= $(DESTDIR)$(PREFIX)/share/man
LIBDIR ?= $(DESTDIR)$(PREFIX)/lib
DATADIR ?= $(DESTDIR)$(PREFIX)/share/crystal
INSTALL ?= /usr/bin/install

ifeq ($(or $(TERM),$(TERM),dumb),dumb)
  colorize = $(shell printf >&2 "$1")
else
  colorize = $(shell printf >&2 "\033[33m$1\033[0m\n")
endif

check_llvm_config = $(eval \
	check_llvm_config := $(if $(LLVM_VERSION),\
	  $(call colorize,Using $(LLVM_CONFIG) [version=$(LLVM_VERSION)]),\
	  $(error "Could not locate compatible llvm-config, make sure it is installed and in your PATH, or set LLVM_CONFIG. Compatible versions: $(shell cat src/llvm/ext/llvm-versions.txt)))\
	)

.PHONY: all
all: crystal ## Build all files (currently crystal only) [default]

.PHONY: spec
spec: $(O)/all_spec ## Run all specs
	$(O)/all_spec $(SPEC_FLAGS)

.PHONY: std_spec
std_spec: $(O)/std_spec ## Run standard library specs
	$(O)/std_spec $(SPEC_FLAGS)

.PHONY: compiler_spec
compiler_spec: $(O)/compiler_spec ## Run compiler specs
	$(O)/compiler_spec $(SPEC_FLAGS)

.PHONY: primitives_spec
primitives_spec: $(O)/primitives_spec ## Run primitives specs
	$(O)/primitives_spec $(SPEC_FLAGS)

.PHONY: smoke_test
smoke_test: ## Build specs as a smoke test
smoke_test: $(O)/std_spec $(O)/compiler_spec $(O)/crystal

.PHONY: samples
samples: ## Build example programs
	$(MAKE) -C samples

.PHONY: docs
docs: ## Generate standard library documentation
	$(call check_llvm_config)
	./bin/crystal docs src/docs_main.cr $(DOCS_OPTIONS) --project-name=Crystal --project-version=$(CRYSTAL_VERSION) --source-refname=$(CRYSTAL_CONFIG_BUILD_COMMIT)

.PHONY: crystal
crystal: $(O)/crystal ## Build the compiler

.PHONY: deps llvm_ext
deps: $(DEPS) ## Build dependencies
llvm_ext: $(LLVM_EXT_OBJ)

.PHONY: format
format: ## Format sources
	./bin/crystal tool format$(if $(check), --check) src spec samples

.PHONY: install
install: $(O)/crystal man/crystal.1.gz ## Install the compiler at DESTDIR
	$(INSTALL) -d -m 0755 "$(BINDIR)/"
	$(INSTALL) -m 0755 "$(O)/crystal" "$(BINDIR)/crystal"

	$(INSTALL) -d -m 0755 $(DATADIR)
	cp -av src "$(DATADIR)/src"
	rm -rf "$(DATADIR)/$(LLVM_EXT_OBJ)" # Don't install llvm_ext.o

	$(INSTALL) -d -m 0755 "$(MANDIR)/man1/"
	$(INSTALL) -m 644 man/crystal.1.gz "$(MANDIR)/man1/crystal.1.gz"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/licenses/crystal/"
	$(INSTALL) -m 644 LICENSE "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/"
	$(INSTALL) -m 644 etc/completion.bash "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/"
	$(INSTALL) -m 644 etc/completion.zsh "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"
	$(INSTALL) -d -m 0755 "$(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/"
	$(INSTALL) -m 644 etc/completion.fish "$(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/crystal.fish"

.PHONY: uninstall
uninstall: ## Uninstall the compiler from DESTDIR
	rm -f "$(BINDIR)/crystal"

	rm -rf "$(DATADIR)/src"

	rm -f "$(MANDIR)/man1/crystal.1.gz"
	rm -f "$(DESTDIR)$(PREFIX)/share/licenses/crystal/LICENSE"

	rm -f "$(DESTDIR)$(PREFIX)/share/bash-completion/completions/crystal"
	rm -f "$(DESTDIR)$(PREFIX)/share/zsh/site-functions/_crystal"

.PHONY: install_docs
install_docs: docs ## Install docs at DESTDIR
	$(INSTALL) -d -m 0755 $(DATADIR)

	cp -av docs "$(DATADIR)/docs"
	cp -av samples "$(DATADIR)/examples"

.PHONY: uninstall_docs
uninstall_docs: ## Uninstall docs from DESTDIR
	rm -rf "$(DATADIR)/docs"
	rm -rf "$(DATADIR)/examples"

$(O)/all_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/all_spec.cr

$(O)/std_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/std_spec.cr

$(O)/compiler_spec: $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORT_CC) $(EXPORTS) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/compiler_spec.cr

$(O)/primitives_spec: $(O)/crystal $(DEPS) $(SOURCES) $(SPEC_SOURCES)
	@mkdir -p $(O)
	$(EXPORT_CC) ./bin/crystal build $(FLAGS) $(SPEC_WARNINGS_OFF) -o $@ spec/primitives_spec.cr

$(O)/crystal: $(DEPS) $(SOURCES)
	$(call check_llvm_config)
	@mkdir -p $(O)
	$(EXPORTS) $(EXPORTS_BUILD) ./bin/crystal build $(FLAGS) -o $@ src/compiler/crystal.cr -D without_openssl -D without_zlib

$(LLVM_EXT_OBJ): $(LLVM_EXT_DIR)/llvm_ext.cc
	$(call check_llvm_config)
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(shell $(LLVM_CONFIG) --cxxflags)

man/%.gz: man/%
	gzip -c -9 $< > $@

.PHONY: clean
clean: clean_crystal ## Clean up built directories and files
	rm -rf $(LLVM_EXT_OBJ)

.PHONY: clean_crystal
clean_crystal: ## Clean up crystal built files
	rm -rf $(O)
	rm -rf ./docs

.PHONY: clean_cache
clean_cache: ## Clean up CRYSTAL_CACHE_DIR files
	rm -rf $(shell ./bin/crystal env CRYSTAL_CACHE_DIR)

.PHONY: help
help: ## Show this help
	@echo
	@printf '\033[34mtargets:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = ":.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34moptional variables:\033[0m\n'
	@grep -hE '^[a-zA-Z_-]+ \?=.*?## .*$$' $(MAKEFILE_LIST) |\
		sort |\
		awk 'BEGIN {FS = " \\?=.*?## "}; {printf "  \033[36m%-15s\033[0m %s\n", $$1, $$2}'
	@echo
	@printf '\033[34mrecipes:\033[0m\n'
	@grep -hE '^##.*$$' $(MAKEFILE_LIST) |\
		awk 'BEGIN {FS = "## "}; /^## [a-zA-Z_-]/ {printf "  \033[36m%s\033[0m\n", $$2}; /^##  / {printf "  %s\n", $$2}'

=== debian/changelog ===
crystal (1.6.0+dfsg-3) unstable; urgency=medium

  * Update runtime depends (Closes: #1031812).

 -- David Suárez <deiv@debian.org>  Fri, 03 Mar 2023 19:03:34 +0100

crystal (1.6.0+dfsg-2) unstable; urgency=medium

  * Source upload.

 -- David Suárez <deiv@debian.org>  Tue, 11 Oct 2022 21:08:52 +0200

crystal (1.6.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * d/patches:
    - Refresh patch 'remove-check-in-random-failing-test'.
    - Add patch 'fix-sbuild-pkgbuilddir-filtering-in-unix-spec'
      (Closes: #1017565).
  * Switch to llvm-toolchain-14 (Closes: #1017662).

 -- David Suárez <deiv@debian.org>  Sun, 09 Oct 2022 20:02:18 +0200

=== debian/control ===
--- 
+++ 
@@ -15,10 +15,10 @@
                libxml2-dev,
                libyaml-dev,
                libz-dev,
-               lld-13,
-               llvm-13-dev,
+               lld-14,
+               llvm-14-dev,
                pkg-config,
-               crystal (>= 1.2.1)
+               crystal (>= 1.6.0)
 Standards-Version: 4.6.1
 Homepage: https://crystal-lang.org/
 Vcs-Git: https://salsa.debian.org/deiv/crystal.git
@@ -27,10 +27,14 @@
 
 Package: crystal
 Architecture: amd64
-Depends: pkg-config,
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libgc-dev
+         gcc,
+         libgc-dev,
+         pkg-config,
+         libpcre3-dev,
+         libevent-dev
+Recommends: libssl-dev, libz-dev, libxml2-dev, libgmp-dev, libyaml-dev
 Suggests: crystal-doc, crystal-samples
 Description: compiler of the Crystal object-oriented programming language
  The Crystal's language syntax is inspired by Ruby, the language is statically

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,7 @@
 make_options += threads=$(N_CPUS)
 make_options += CRYSTAL_CONFIG_PATH="lib:/usr/lib/crystal/lib"
 make_options += CRYSTAL_CACHE_DIR="/tmp/crystal"
+#make_options += interpreter=1
 
 export FLAGS = -Dwithout_playground
